-- Part of this script is used from DMC's Weapon Overhaul - https://github.com/DeadMansChest/DMCWO
function BlackMarketManager:fire_rate_multiplier(name, categories, silencer, detection_risk, current_state, blueprint)
	local factory_id = managers.weapon_factory:get_factory_id_by_weapon_id(name)
	local tweak_data = tweak_data.weapon
	local weapon = tweak_data[name]
	local factory = tweak_data.factory[factory_id]
	if factory then
		local default_blueprint = factory.default_blueprint
		local custom_stats = managers.weapon_factory:get_custom_stats_from_weapon(factory_id, blueprint or default_blueprint)
		local rof_multiplier = 1
		local multiplier = 1
		multiplier = multiplier + 1 - managers.player:upgrade_value(name, "fire_rate_multiplier", 1)
		multiplier = multiplier + 1 - managers.player:upgrade_value("weapon", "fire_rate_multiplier", 1)

		for _, category in ipairs(categories) do
			multiplier = multiplier + 1 - managers.player:upgrade_value(category, "fire_rate_multiplier", 1)
		end

		for part_id, stats in pairs(custom_stats) do
			if stats.rof_mult then
				if stats.rof_mult > 1 then
					multiplier = multiplier + 1 - rof_multiplier * stats.rof_mult
				elseif stats.rof_mult < 1 then
					multiplier = multiplier / stats.rof_mult
				else
					multiplier = multiplier
				end
			end
		end

		return self:_convert_add_to_mul(multiplier)
	end
end