-- This script is used from DMC's Weapon Overhaul - https://github.com/DeadMansChest/DMCWO
Hooks:PostHook(NewRaycastWeaponBase, "_update_stats_values", "FireRateAttachInit", function(self)
	self._rof_mult = 1
	local custom_stats = managers.weapon_factory:get_custom_stats_from_weapon(self._factory_id, self._blueprint)
	for part_id, stats in pairs(custom_stats) do
		if stats.rof_mult then
			self._rof_mult = self._rof_mult * stats.rof_mult
		end
	end
end)
function NewRaycastWeaponBase:fire_rate_multiplier()
	local multiplier = self._rof_mult or 1
	if NewRaycastWeaponBase.DEFAULT_BURST_SIZE then
		if self._fire_mode == Idstring("auto") and not self:in_burst_mode() and self._auto_fire_rate_multiplier then
			multiplier = multiplier * self._auto_fire_rate_multiplier
		end
	else
		if self._fire_mode == Idstring("auto") and self._auto_fire_rate_multiplier then
			multiplier = multiplier * self._auto_fire_rate_multiplier
		end
	end

	if NewRaycastWeaponBase.DEFAULT_BURST_SIZE then
		return multiplier * ( (self:in_burst_mode() and self._burst_fire_rate_multiplier) or 1)
	else
		return multiplier * (self._burst_fire_rate_multiplier or 1)
	end
end